import React, { Component } from 'react';
import './SearchRow.css';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { DatePickerWrapper } from '../../MultiReferenceFilterSearch/DatePickerWrapper/DatePickerWrapper';
import moment from 'moment'
import axios from 'axios'
import {CSVLink } from "react-csv";

export class SearchRow extends Component {
  constructor(props){
    super(props);
    this.state = {
      data : [],
      csvDataLoaded : "none",
      csvDateFields : this.props.csvDateFields !== undefined ? this.props.csvDateFields : [],
      csvUTCFields : this.props.csvUTCFields !== undefined ? this.props.csvUTCFields : []
    };

    this.csvLink = React.createRef();
    // this.updateKeyword = this.updateKeyword.bind(this);
    console.log('Hey I am the search row props', this.props)
    this.getCSV = this.getCSV.bind(this)
  }
  getCSV(){
    // console.log('hitCSV',linkButton)
    this.setState({
      csvDataLoaded : "loading",
    }, () => {
      axios.get(this.props.csvUrl).then(resp=>{
        // console.log(resp.data)
        // let newData = { data: [
        // {
        //   timeStamp:moment().startOf('day').valueOf(), 
        //   timeStampUTC:moment().startOf('day').valueOf(), 
        //   value : "hello world today"
        // },{
        //   timeStamp:moment().subtract(1, 'days').startOf('day').add('42', "minutes").valueOf(),
        //   timeStampUTC:moment().startOf('day').valueOf(), 
        //   value : "hello world minus 1"
        // },{
        //   timeStamp:moment().tz("Australia/Adelaide").subtract(1, 'days').startOf('day').add('42', "minutes").valueOf(),
        //   timeStampUTC:moment().tz("Australia/Adelaide").subtract(1, 'days').startOf('day').add('42', "minutes").valueOf(),
        //   value : "hello world minus 1"
        // },{
        //   timeStamp:moment().subtract(2, 'days').startOf('day').add('21', "hours").valueOf(),
        //   timeStampUTC:moment().subtract(2, 'days').startOf('day').add('21', "hours").valueOf(),
        //   value : "hello world minus 2"
        // },{
        //   timeStamp:0,
        //   timeStampUTC:0,
        //   value : "hello world minus 3"
        // }]}
        resp.data.forEach(row=>{
          this.state.csvDateFields.forEach(field => {
            row[`${field}`] === null || row[`${field}`] === 0 ? row[`${field}`] = "" : row[`${field}`] = moment(row[`${field}`]).format("YYYY-MM-DD HH:mm") 
          })
          this.state.csvUTCFields.forEach(field =>{
            row[`${field}`] === null || row[`${field}`] === 0 ? row[`${field}`] = "" : row[`${field}`] = moment(row[`${field}`]).utc().format("YYYY-MM-DD HH:mm") 
          })
        })
        this.setState({
          data : resp.data,
          csvDataLoaded: "loaded"
        },() => {
          // let elem = document.getElementById('csv_link_FGP_search_x_p');
          // this.csvLink.current.link.click()
        })
      })
    })
  }

  componentWillReceiveProps(props){
    if(props.csvUrl !== this.props.csvUrl){
      this.setState({
        csvDataLoaded : "none",
      })
    }
  }

  render() {
    return (
      <div className="col-12 row fgReact_searchrow d-inline-flex align-items-center">
        <div className={"col-md-3 col-12 fgReact_searchInputContainer d-md-inline-flex align-items-center"}>
          <select className="form-control" value={this.props.searchingColumn} onChange={this.props.updateSearchingColumn}>>
            {
              this.props.searchingColumns.map((option, i) => {
                return (
                  <option key={i} value={option.column}>{option.label}</option>
                )
              })
            }
          </select>
        </div>
        {
          this.props.searchingColumns[this.props.searchingColumns.findIndex( row => row.column === this.props.searchingColumn )]["isTs"] === true ? (
              <div className={"col-md-3 col-12 d-md-inline-flex align-items-center fgReact_searchInputContainer"}>
                <select className="form-control " value={this.props.searchingType} onChange={this.props.updateSearchingType}>
                  {
                    this.props.dateSearchingTypes.map((option, i) => {
                      return (
                        <option key={i} value={option.key}>{option.label}</option>
                        )
                      })
                  }
                </select>
              </div>
            ):(
              <div className={"col-md-3 col-12 d-md-inline-flex align-items-center fgReact_searchInputContainer"}>
                <select className="form-control " value={this.props.searchingType} onChange={this.props.updateSearchingType}>
                  {
                    this.props.searchingTypes.map((option, i) => {
                      return (
                        <option key={i} value={option.key}>{option.label}</option>
                        )
                      })
                  }
                </select>
              </div>
            )
        }

        {
          this.props.searchingColumns[this.props.searchingColumns.findIndex( row => row.column === this.props.searchingColumn )]["isTs"] === true ? (

            <DatePickerWrapper
              customClasses={" col-md-3 col-12 d-md-inline-flex align-items-center"}
              date={this.props.searchingKeyword}
              handleChange={this.props.updateDateTime}
            />
            )  : (
            <div className={"col-md-3 col-12 d-md-inline-flex align-items-center fgReact_searchInputContainer "}>
              <input className="form-control" placeholder="Keyword..." value={this.props.searchingKeyword} onChange={this.props.updateKeyword} onKeyPress={(event) => {
                            if (event.key === "Enter") {
                              this.props.makeSearch()
                            }
                          }}>
              </input>
            </div>
          )
        }

          <div className="d-inline-flex align-items-center col-12 col-md-3 ">
          {
            this.props.isFirst === true ? (
                  <button className="btn btn-secondary" style={{"marginRight":"10px"}} onClick={this.props.addSearchCriteria}>
                    <FontAwesomeIcon className="" icon={["fas", "plus"]}/>
                  </button>
              )
              : (
                  <button className="btn btn-secondary" onClick={() => this.props.removeSearchCriteria(this.props.indexKey)}>
                    <FontAwesomeIcon className="" icon={["fas", "minus"]}/>
                  </button>
              )
            }
          {
            this.props.isFirst === true ? (
                  <div style={{"display" : "contents"}}>
                    <button className="btn btn-primary" onClick={this.props.makeSearch}>
                        <FontAwesomeIcon className="" icon={["fas", "search"]}/>
                    </button>
                    {
                      this.props.hasResultMap === true ? (
                        <button className="btn btn-secondary" style={{"marginLeft":"10px"}} onClick={this.props.toggleMap}>
                          <FontAwesomeIcon className="" icon={["fas", "map"]}/>
                        </button>
                      ) : (
                        ""
                      )
                    }

                  </div>
              )
              : (
                ""
              )
            }
            {
              this.props.exportCsv === true && this.props.isFirst === true ? (
                <div style={{"display" : "contents"}}>
                {
                  this.state.csvDataLoaded === "none" ? (
                    <div className="btn btn-secondary"  onClick={this.getCSV}  style={{"marginLeft":"10px"}}>
                      <FontAwesomeIcon className=""  icon={["fas", "download"]}></FontAwesomeIcon>
                    </div>
                  ): this.state.csvDataLoaded === "loaded" ? (
                      <CSVLink ref={this.csvLink} id="csv_link_FGP_search_x_p" className={"btn btn-secondary"}  style={{"marginLeft":"10px", "color":"white"}} data={this.state.data} filename={"search_result.csv"} >
                          <FontAwesomeIcon className=""   icon={["fas", "file-download"]}></FontAwesomeIcon>
                      </CSVLink>
                    
                  ):(
                    <div className="btn btn-secondary"  onClick={this.getCSV}  style={{"marginLeft":"10px"}}>
                      <FontAwesomeIcon className=" fa-spin "  icon={["fas", "spinner"]}/>
                    </div>
                  )
                }
                  
                </div>
              ) : (
                ""
              )
            }
          </div>

      </div>
    )
  }
}

export default SearchRow
